/* GA-related headers */
//#include <ga/ga.h>

/* ARGoS-related headers */
#include <iostream>
#include <argos3/core/simulator/simulator.h>
#include <argos3/core/simulator/loop_functions.h>
//
#include <argos3/plugins/robots/kilobot/simulator/kilobot_entity.h>

//#include </Users/szilard/argos3-kilobot-master/src/plugins/robots/kilobot/control_interface/message.h>
//#include </Users/szilard/argos3-kilobot-master/src/plugins/robots/kilobot/control_interface/message_crc.h>

using namespace argos;

// GAlib-related headers
#include <ga/ga.h>
#include <ga/GARealGenome.h>



/****************************************/
/****************************************/
#include <fstream>
#include <string>
#include <stdio.h>
#include <dirent.h>
using namespace std;

//#include "/Users/szilard/argos3-kilobot-master/src/embedding/galib/performance_evaluation.cpp"
#include <vector>
#include <sstream>
#include <fstream>
#include <cmath>

//for creating a new folder
#include <sys/stat.h>

int CopyFile(string initialFilePath, string outputFilePath)
{
    
    ifstream initialFile(initialFilePath.c_str(), ios::in|ios::binary);
    ofstream outputFile(outputFilePath.c_str(), ios::out|ios::binary);
    //defines the size of the buffer
    initialFile.seekg(0, ios::end);
    long fileSize = initialFile.tellg();
    //Requests the buffer of the predefined size
    
    
    //As long as both the input and output files are open...
    if(initialFile.is_open() && outputFile.is_open())
    {
        short * buffer = new short[fileSize/2];
        //Determine the file's size
        //Then starts from the beginning
        initialFile.seekg(0, ios::beg);
        //Then read enough of the file to fill the buffer
        initialFile.read((char*)buffer, fileSize);
        //And then write out all that was read
        outputFile.write((char*)buffer, fileSize);
        delete[] buffer;
    }
    //If there were any problems with the copying process, let the user know
    else if(!outputFile.is_open())
    {
        cout<<"I couldn't open "<<outputFilePath<<" for copying!\n";
        return 0;
    }
    else if(!initialFile.is_open())
    {
        cout<<"I couldn't open "<<initialFilePath<<" for copying!\n";
        return 0;
    }
    
    initialFile.close();
    outputFile.close();
    
    return 1;
}

std::string path_of_data = "/argos3-kilobot-master/src/examples/behaviors/data";
int kilo_uid[] = {4, 6};
const char* homeDir = getenv ("HOME");
    
void newFolder(int trial_num){
    std::string trial_num_s = std::to_string(trial_num);
    const char* trial_num_sp = &trial_num_s[0];
    char final_dir [200];
    
    //Creating the folder
    sprintf (final_dir, "%s%s/Trial_%s",homeDir, &path_of_data[0], trial_num_sp);
    mkdir(final_dir, ACCESSPERMS);

    //Copying the files to the new folder
    for (int i = 0; i < sizeof(kilo_uid)/sizeof(int); i++) {
    	std::string kilo_uid_s = std::to_string(kilo_uid[i]);
		const char *kilo_uid_sp = &kilo_uid_s[0];

    	char path_of_old_file [200];
    	sprintf (path_of_old_file, "%s%s/coords%s.csv",homeDir, &path_of_data[0], kilo_uid_sp);

    	char path_of_new_file [200];
    	sprintf (path_of_new_file, "%s%s/Trial_%s/coords%s.csv",homeDir, &path_of_data[0], trial_num_sp, kilo_uid_sp);

        CopyFile(path_of_old_file, path_of_new_file);
    }
    
}

//void removeFolder(int trial_num){
//    const char* homeDir = getenv ("HOME");
//    std::string trial_num_s = std::to_string(trial_num);
//    const char* trial_num_sp = &trial_num_s[0];
//    char final_dir [200];
//
//    
//    //Removing all files in the folder
//    for (int i = 0; i < sizeof(kilo_uid); i++) {
//        std::string kilo_uid_s = std::to_string(kilo_uid[i]);
//        const char *kilo_uid_sp = &kilo_uid_s[0];
//        sprintf (final_dir, "%s%s/Trial_%s/kilobot_%s.txt",homeDir, &path_of_data[0], trial_num_sp, kilo_uid_sp);
//        remove(final_dir);
//    }
//    
//    //Removing the folder itself
//    sprintf (final_dir, "%s%s/Trial_%s",homeDir, &path_of_data[0], trial_num_sp);
//    remove(final_dir);
//}

void write_PID_values( double cp_longitudinal,
                      double ci_longitudinal,
                      double cd_longitudinal,
                      double cp_transversal_lr,
                      double ci_transversal_lr,
                      double cd_transversal_lr,
                      double cp_transversal_diag,
                      double ci_transversal_diag ,
                      double cd_transversal_diag,
                      double cp_angle ){

    ofstream file("/Users/szilard/argos3-kilobot-master/src/examples/behaviors/pid_values.csv");
    file << cp_longitudinal << "\n";
    file << ci_longitudinal << "\n";
    file << cd_longitudinal << "\n";
    
    file << cp_transversal_lr << "\n";
    file << ci_transversal_lr << "\n";
    file << cd_transversal_lr << "\n";
    
    file << cp_transversal_diag << "\n";
    file << ci_transversal_diag << "\n";
    file << cd_transversal_diag << "\n";
    
    file << cp_angle << "\n";
    
    file.close();
}

int trial = 0; // To count how many times LaunchARGoS was called
float LaunchARGoS(GAGenome& c_genome){

    /* Convert the received genome to the actual genome type */
    GARealGenome& cRealGenome = dynamic_cast<GARealGenome&>(c_genome);

    clog << "New PID value are at Trial #" <<  trial << ": ";
    clog << cRealGenome;
    clog << "\n";

    
    static argos::CSimulator& cSimulator = argos::CSimulator::GetInstance();
  	cSimulator.Reset();

  	/*
  	argos::CSpace::TMapPerType& tKBMap = cSimulator.GetSpace().GetEntitiesByType("kilobot");
  	//clog << "LaunchARGoS started\n";
  	while(!cSimulator.IsExperimentFinished()) {
  		cSimulator.UpdateSpace();
  		for(CSpace::TMapPerType::iterator it = tKBMap.begin();
  		    it != tKBMap.end();
  		    ++it) {

  					CKilobotEntity* pcKB = any_cast<CKilobotEntity*>(it->second);
  					//std::clog << "I am Kilobot" << pcKB->GetId() << "\n";
  		}		
  	}
    //clog << "End of evaluation number " << trial << "\n";

	// Copying generated files to a new folder
	newFolder(trial);

	// Setting up path for the cEvaluator
	char path_of_cord [200];
	sprintf (path_of_cord, "%s%s/Trial_%i/coords4.csv",homeDir, &path_of_data[0], trial);
    const char *final_dir_p = &path_of_cord[0];
    // Creating a class member
	CperformanceEvaluator cEvaluator;
	// Reading the file
	auto inputDir = final_dir_p;
	cEvaluator.getInputDir(inputDir);
	cEvaluator.readFile();
	// Calculating the performance
	cEvaluator.calcPerformance();
		

	// Setting up the path for the performance evaluation - path of folder
	char path_of_cost [200];
	sprintf (path_of_cost, "%s%s/Trial_%i",homeDir, &path_of_data[0], trial);
	// Setting up the path for the performance evaluation - path of output txt
	char final_dir2[200];
	sprintf(final_dir2, "%s/cost.txt", &path_of_cost[0]);
	const char *cost_filename = &final_dir2[0];
	// Writing the performnace into file
	auto outputDir = cost_filename;
	cEvaluator.getOutputDir(outputDir);
	cEvaluator.writeCost();
	*/

	
	trial++;

	// Temporal cost function
    float value=0.0;
    for(int i=1; i<cRealGenome.length(); i++)
        if(cRealGenome.gene(i) > cRealGenome.gene(i-1)) value += 1.0;
    return value;



    //return cEvaluator.getCost();
}



int main(int argc, char** argv) {

	static argos::CSimulator& cSimulator = argos::CSimulator::GetInstance();
  	cSimulator.SetExperimentFileName("src/examples/experiments/square0.argos");
  	cSimulator.LoadExperiment();
  	
	
	
	GARealAlleleSetArray cRealAlleleSet;
    // Longitudinal PID
    cRealAlleleSet.add(0,10);
    cRealAlleleSet.add(0,10);
    cRealAlleleSet.add(0,10);
    // Transversal LR PID
    cRealAlleleSet.add(0,10);
    cRealAlleleSet.add(0,10);
    cRealAlleleSet.add(0,10);
    // Transversal DIAG PID
    cRealAlleleSet.add(0,10);
    cRealAlleleSet.add(0,10);
    cRealAlleleSet.add(0,10);
    // Angle PID
    cRealAlleleSet.add(0,100);

    // Temporal Allel
    GARealAlleleSet tmp_allel(0,10,0.5,GAAllele::INCLUSIVE,GAAllele::EXCLUSIVE);
    GARealGenome cGenome(10, tmp_allel, LaunchARGoS);
    //GARealGenome cGenome(cRealAlleleSet, LaunchARGoS);
    cGenome.crossover(GARealUniformCrossover);
    cGenome.mutator(GARealSwapMutator);
    
    //cGenome.UniformInitializer(cGenome);

    // To initialize the genom
    for (int i = 0; i < cGenome.size(); ++i)
   	{
   		clog << "	:" << cGenome.gene(i, i) << "\n";
   	}
   	

   	GASimpleGA cGA(cGenome);
   	cGA.minimize();                     // the objective function must be minimized
   	cGA.populationSize(20);              // population size for each generation
   	cGA.nGenerations(100);              // number of generations
   	cGA.pMutation(0.05f);               // prob of gene mutation
   	cGA.pCrossover(0.15f);              // prob of gene crossover
   	cGA.scoreFilename("evolution.dat"); // filename for the result log
   	cGA.flushFrequency(1);              // log the results every generation


   	do
   	{
   		cGA.step();
   		for (unsigned int i = 0; i < cGA.population().size(); i++) {
        	clog << cGA.population().individual(i);
        	clog << "\n";
    	}
    	clog << "\n";
   	} while (!cGA.done());

   	clog << "And the best individual at the end is: " << cGA.statistics().bestIndividual() << "\n";
   	
  	cSimulator.Destroy();
   	return 0;
}

/****************************************/
/****************************************/
