clear all; close all; clc;
%% Reading in the data
data_GOD = csvread(['data_GOD' '4' '.csv']);
data = csvread(['data' '4' '.csv']);

%Ez így nem jó, mert nem ugyanakkor és nem ugyanannyi adatot mentenek
%További variálásra van szükség, ha a többi robot információjára is
%kíváncsiak vagyunk. De talán nem kell, bár biztos segítene.

% data2 = csvread(['data' '6' '.csv']);
% data2(:,1) = [];
% data = [data, data2];

%% Output
output = data_GOD(:,end);
%% Just out of courtesy, I add the real angle data to the "data"
data = [ data output ];


%% Input without filtering
if 1
    data_filtered = data;
end

%% Input with filtering
% Input is more tricky. We want to feed in more data, not just data from the
% last iteration.

if 0
    %This is with filtering, but we don't want to do that
    starting = 1; ending = size(data,1);
    a = 1; b = ones(1,1) / 1;
    figure(1);
    data_filtered(:,1) = data(:,1);
    for i = 2:size(data,2)
        data_filtered(:,i) = filter(b,a,data(starting:ending,i));
        subplot(3,3,i-1);
        hold on;
        plot(data_filtered(:,1), data_filtered(:,i));
        plot(data(:,1), data(:,i));
    end
    
    % ---- This needs to be changed if KiloID changes ---- %
    %Here we are deleting the massive jumps
    data_filtered(data_filtered(:, [4+1]) > 0.004, 4+1) =  0.004;
    data_filtered(data_filtered(:, [4+1]) < -0.004, 4+1) =  -0.004;
    data_filtered(data_filtered(:, [6+1]) > 0.004, 6+1) =  0.004;
    data_filtered(data_filtered(:, [6+1]) < -0.004, 6+1) =  -0.004;
    
    for i = 2:size(data,2)
        subplot(3,3,i-1);
        hold on;
        plot(data_filtered(:,1), data_filtered(:,i), '-.');
    end
    
end %enable or disable filtering

%% Plotting the final data
% ---- This needs to be changed if KiloID changes ---- %
input = data_filtered(:,[1 3 4 6 7 8]+1);
%%
figure(2);
subplot(2,3,1);
plot(data_filtered(:,1), input(:,1));
title('Front - Longitudinal');
subplot(2,3,2);
plot(data_filtered(:,1), input(:,2));
title('Right - Longitudinal');
subplot(2,3,3);
plot(data_filtered(:,1), input(:,3));
title('Front - Transversal');
subplot(2,3,4);
plot(data_filtered(:,1), input(:,4));
title('Right - Transversal');
subplot(2,3,5);
plot(data_filtered(:,1), input(:,5));
title('Delay - Longitudinal');
subplot(2,3,6);
plot(data_filtered(:,1), input(:,6));
title('Delay - Transversal');


%% Plotting the resultant data


for i = 1:size(data,1)
    neural_output(i,1) = myNeuralNetworkFunction2(input(i,:));
end

%Filtering neural_output
starting = 1; ending = size(data,1);
a = 1; b = ones(1,10) / 10;

neural_output_filtered = filter(b,a,neural_output);



% neural_output = myNeuralNetworkFunction(input);
figure(3);
hold on;
plot(data(:,1), output);
plot(data(:,1), neural_output, '-.');
plot(data(:,1), neural_output_filtered, 'black');
legend('output', 'neural output', 'neural output filtered');
title('True and calculated angle data')
grid on

%% create network
% net = network(1,2,[1;0],[1; 0],[0 0; 1 0],[0 1]);
% view(net);
% %%
% clear all; clc
% net = network( ...
% 1, ... % numInputs,    number of inputs,
% 3, ... % numLayers,    number of layers
% [1; 0; 0], ... % biasConnect,  numLayers-by-1 Boolean vector,
% [1; 0; 0], ... % inputConnect, numLayers-by-numInputs Boolean matrix,
% [0 0; 1 0], ... % layerConnect, numLayers-by-numLayers Boolean matrix
% [0 1]       ... % outputConnect, 1-by-numLayers Boolean vector
% );
% % View network structure
% view(net);
% %%
%     [x,t] = bodyfat_dataset;
%     net = fitnet(10);
%     view(net);
%
%     %%
%     net = train(net,x,t);
%     view(net)
%     y = net(x);