function [neural_output_filtered, net] = kilobot_x_plot_angles( input, output, data, histerese, histerese_enabled, mean_and_std_output, angle_diff_K2K4, angle_diff_K2K6 )

%% Predicting with ML
%--Either using precomputed neural network
% for i = 1:size(data,1)
%     if i == size(data,1)
%         kappa = 69;
%     end
%     neural_output(i,1) = kilobot_x_neural_function(input(i,:));
% end

% %--Or by training & saving a new one
% [net] = feedforwardnet([60 20 5]);
% [net] = feedforwardnet([100 40 20 5]);
% [net] = feedforwardnet([50]);
net = 0;
% [net] = train(net, input', output');
% t = 0;
save('net', 'net');

% genFunction(net,'kilobot_x_neural_function_netgen')
% load('new_10and06');
t = 0;
% output = round(output);
for i = 1:size(data,1)
    if i == size(data,1)
        kappa = 69;
    end
%         neural_output(i,1) = net(input(i,:)');
        neural_output(i,1) = kilobot_x_neural_function(input(i,:));
    %     [Yf,Xf,Af] = kilobot_x_neural_function_netgen(input(i,:));
    %     [y] = kilobot_x_neural_function(input(i,:));
    %     neural_output(i,1) = mean(Yf(1,:));
end
%% Filtering neural_output

starting = 1; ending = size(data,1);
a = 1; b = ones(1,1) / 1;
neural_output_filtered = filter(b,a,neural_output);

% starting = 1; ending = size(data,1);
% a = 1; b = ones(1,3) / 3;
% neural_output_filtered = filter(b,a,neural_output);

if histerese_enabled
    flip_prop = 3;
    neural_output_filtered( neural_output_filtered > histerese / flip_prop ) = histerese;
    neural_output_filtered( neural_output_filtered < -histerese / flip_prop ) = -histerese;
    neural_output_filtered( neural_output_filtered > -histerese / flip_prop & neural_output_filtered < histerese / flip_prop ) = 0;
end




%% Converting back
neural_output_filtered = neural_output_filtered * mean_and_std_output(2);
neural_output_filtered = neural_output_filtered + mean_and_std_output(1);
output = output * mean_and_std_output(2);
output = output + mean_and_std_output(1);

%% Plotting
figure(3);
hold on;
plot(data(:,1), output);
% plot(data(:,1), neural_output, '-.');
plot(data(:,1), neural_output_filtered, 'black');
% legend({'real angle', 'ML angle', 'ML angle filtered'}, 'FontSize', 16);
set(gca,'FontSize',16)
title('True and calculated angle data')
ylabel({'Angle in degrees'}, 'FontSize', 16);
xlabel({'Time in ms'}, 'FontSize', 16);
grid on
drawnow;
% figure(4)
% for i = 1:size(data(:,1))
%    if ( (abs(angle_diff_K2K4(i)) > 0.5 | abs(angle_diff_K2K6(i)) > 0.5) )
%        hold on
%        plot(data(i,1), output(i), 'ro');
%    end
% end
figure(3)
plot(data((abs(angle_diff_K2K4(:)) > 0.5 | abs(angle_diff_K2K6(:)) > 0.5),1), output((abs(angle_diff_K2K4(:)) > 0.5 | abs(angle_diff_K2K6(:)) > 0.5)), 'ro', 'MarkerSize', 2);
legend({'real angle', 'ML angle', '> 0.5 angle diff'}, 'FontSize', 16);


%Látunk bármit, ha kiplottoljuk az inputot?
% figure(4);
% for i = 1:size(input,2)
%    subplot(3,3,i);
% %     figure(3+i)
%    plot(data(:,1), input(:,i));
% end

angle_diff = 15;
plot_1r = input( abs (output - neural_output_filtered ) > angle_diff ,4);
plot_1k = input( abs (output - neural_output_filtered ) <= angle_diff ,4);
plot_2r = input( abs (output - neural_output_filtered ) > angle_diff ,5);
plot_2k = input( abs (output - neural_output_filtered ) <= angle_diff ,5);

figure(4)
subplot(2,1,1)
hold on;
plot(plot_1k, plot_2k, 'k.')
hold on;
plot(plot_1r, plot_2r, 'r.')
title('Mistakes when K4 moves');
drawnow;

plot_1r = input( abs (output - neural_output_filtered ) > angle_diff ,8);
plot_1k = input( abs (output - neural_output_filtered ) <= angle_diff ,8);
plot_2r = input( abs (output - neural_output_filtered ) > angle_diff ,9);
plot_2k = input( abs (output - neural_output_filtered ) <= angle_diff ,9);


figure(4)
subplot(2,1,2)
hold on;
plot(plot_1k, plot_2k, 'k.')
hold on;
plot(plot_1r, plot_2r, 'r.')
title('Mistakes when K6 moves');
drawnow;

% figure(4)
% subplot(2,1,1);
% for i = 1:size(input,1)
%    if abs(output(i)) - abs(neural_output_filtered(i)) < -15
%        hold on;
%        plot(input(i,4), input(i,5),'r.');
%    else
%        hold on;
%        plot(input(i,4), input(i,5),'k.');
%    end
% end
% figure(4)
% subplot(2,1,2);
% for i = 1:size(input,1)
%    if abs(output(i)) - abs(neural_output_filtered(i)) < -15
%        hold on;
%        plot(input(i,8), input(i,9),'r.');
%    else
%        hold on;
%        plot(input(i,8), input(i,9),'k.');
%    end
% end
end