clear all, close all, clc
%% Read in data
data_GOD2 = [];
data_GOD4 = [];
data_GOD6 = [];
data2 = [];
data4 = [];
data6 = [];
angle2 = [];
angle4 = [];
angle6 = [];
% kilo_uid = '4';
% folderlist = [  {'_1'},{'_2'},{'_3'},{'_4'},{'_5'}, {'_6'},{'_1_04'},{'_2_04'},{'_3_04'},{'_4_04'} ];
folderlist = [  {'_1_04'},{'_2_04'},{'_3_04'},{'_4_04'} ];
%     folderlist = [  {'_1'},{'_2'},{'_3'},{'_4'},{'_5'}, {'_6'} ];
%     folderlist = [  {'_1_04'}];
for i = 1:size(folderlist,2)
    tmp_read2 = csvread(['alma/' cell2mat(folderlist(i)) '/' 'data_GOD2' '.csv']);
    tmp_read4 = csvread(['alma/' cell2mat(folderlist(i)) '/' 'data_GOD4' '.csv']);
    tmp_read6 = csvread(['alma/' cell2mat(folderlist(i)) '/' 'data_GOD6' '.csv']);
    
    %concatenate-ing different trials
    if i > 1
        for j = 1:size(tmp_read2,1)
            tmp_read2(j,1) = data_GOD2(end, 1) + j * 15; %because time has a 15 stepsize
            tmp_read4(j,1) = data_GOD4(end, 1) + j * 15; %because time has a 15 stepsize
            tmp_read6(j,1) = data_GOD6(end, 1) + j * 15; %because time has a 15 stepsize
        end
    end
    data_GOD2 = [    data_GOD2 ; tmp_read2];
    data_GOD4 = [    data_GOD4 ; tmp_read4];
    data_GOD6 = [    data_GOD6 ; tmp_read6];
    
    data2    = [    data2   ;    csvread(['alma/' cell2mat(folderlist(i)) '/' 'data2' '.csv'])    ];
    data4    = [    data4   ;    csvread(['alma/' cell2mat(folderlist(i)) '/' 'data4' '.csv'])    ];
    data6    = [    data6   ;    csvread(['alma/' cell2mat(folderlist(i)) '/' 'data6' '.csv'])    ];
    
end

%% Movement vector
load('speed_conversion.mat');
%Movements
movement2 = round(data2(:,[7, 8]+1));
movement4 = round(data4(:,[7, 8]+1));
movement6 = round(data6(:,[7, 8]+1));

% movement2(movement2(:,2) == 2,2) = (movement2(movement2(:,2) == 2,2) - 2 + 80)./sqrt(2);
% movement2(movement2(:,2) == 3,2) = (movement2(movement2(:,2) == 3,2) - 3 + 80).*-1./sqrt(2);


%Step length for K2
movement2(:,1) = speed_conversion(movement2(:,1),2);
movement2(movement2(:,2) == 2,2) = speed_conversion(movement2(movement2(:,2) == 2,2) - 2 + 80,2)./sqrt(2); %2 is turning left. Left is positive
movement2(movement2(:,2) == 3,2) = speed_conversion(movement2(movement2(:,2) == 3,2) - 3 + 80,2).*-1./sqrt(2);     %3 is turning right. Right is negative
movement2(:,1) = movement2(:,1) + abs(movement2(:,2));

%Step length for K4
movement4(:,1) = speed_conversion(movement4(:,1),2);
movement4(movement4(:,2) > 0,2) = speed_conversion(movement4(movement4(:,2) > 0,2),2)./sqrt(2);     %If > 0, then it turned left. Which means + direction if x is forward
movement4(movement4(:,2) < 0,2) = speed_conversion(movement4(movement4(:,2) < 0,2).*-1,2).*-1./sqrt(2); %If < 0, then it turned right. Which means a - direction if x is forward
movement4(:,1) = movement4(:,1) + abs(movement4(:,2));

%Step length for K6
movement6(:,1) = speed_conversion(movement6(:,1),2);
movement6(movement6(:,2) > 0,2) = speed_conversion(movement6(movement6(:,2) > 0,2),2)./sqrt(2);
movement6(movement6(:,2) < 0,2) = speed_conversion(movement6(movement6(:,2) < 0,2).* -1,2).*-1./sqrt(2);
movement6(:,1) = movement6(:,1) + abs(movement6(:,2));

%%% Plotting their 'kinda approximate position'
% tmp2 = cumsum(movement2);
% tmp4 = cumsum(movement4);
% tmp6 = cumsum(movement6);
% figure(2)
% plot(tmp2(:,1), tmp2(:,2), 'r')
% hold on;
% plot(tmp4(:,1), tmp4(:,2),'b')
% plot(tmp6(:,1), tmp6(:,2),'c')

%%% ML is workig on this :)
% input = [tmp4, tmp6];
% output = [tmp2];
% for i = 1:size(movement2,1)
%    movement2_neural(i,:) = myNeuralNetworkFunction_tmp(input(i,:));
% end
%
% figure(3);
% plot(output(:,1), output(:,2));
% hold on
% plot(movement2_neural(:,1), movement2_neural(:,2));

%% Calculate all possible positions after movement for K2 & K4 & K6

sample_step = 10000; %Sample step
pos2_after = movement2(sample_step,:);
O2x = pos2_after(1);
O2y = pos2_after(2);
pos2_real = data_GOD2(sample_step, [1, 2]+1);
pos4_real = data_GOD4(sample_step, [1, 2]+1);
pos6_real = data_GOD6(sample_step, [1, 2]+1);
r24 = sqrt(  (pos2_real(1) - pos4_real(1))^2 + (pos2_real(2) - pos4_real(2))^2  );
r26 = sqrt(  (pos2_real(1) - pos6_real(1))^2 + (pos2_real(2) - pos6_real(2))^2  );
r46 = sqrt(  (pos4_real(1) - pos6_real(1))^2 + (pos4_real(2) - pos6_real(2))^2  );
syms O4y O6x O6y
from_x = O2x - r24;
to_x = O2x + r24;
resolution = 100
O4x = linspace(from_x, to_x, resolution);
for j = 1:size(O4x,2)
    %Circle 1
    eq_circle24 = (O4x(j) - O2x)^2 + (O4y - O2y)^2 == r24^2;
    %Circle 2
    eq_circle26 = (O6x - O2x)^2 + (O6y - O2y)^2 == r26^2;
    %Distance between O4 and O6
    eq_distO4O6 = sqrt((O4x(j) - O6x)^2 + (O4y - O6y)^2) == r46;
    disp(['Eqn system number: ' num2str(j)]);
    [O4y_ans{j} O6x_ans{j} O6y_ans{j}] = solve([eq_circle24, eq_circle26, eq_distO4O6], [O4y O6x O6y]);
end
%%
solutions = [];
%we go thorugh each given O4x
row = 1;
for it1 = 1:size(O4x, 2)
    %for each O4x there can be multiple O4y solutions
    for it2 = 1:size(O4y_ans{it1},1)
        solutions(row,:) = [O4x(it1), double(O4y_ans{it1}(it2)), double(O6x_ans{it1}(it2)), double(O6y_ans{it1}(it2)) ];
        row = row + 1;
    end
end


%% Interactive Figure
% figure(1)
% for i = 2:size(solutions,1)
%     plot(O2x, O2y,'go');
%     %Previous informaiton grayed out
%     hold on;
%     plot(solutions(i-1,1), solutions(i-1,2),'kx');
%     hold on;
%     plot(solutions(i-1,3), solutions(i-1,4),'kx');
%     %New information with colot
%     hold on;
%     plot(solutions(i,1), solutions(i,2),'bx');
%     hold on;
%     plot(solutions(i,3), solutions(i,4),'rx');
%     xlim([-0.08 0.08]);
%     ylim([-0.08 0.08]);
%     drawnow;
%     w = waitforbuttonpress;
% end

%% Non-interactive Figure
figure(1)
plot(O2x, O2y,'o');
hold on;
plot(solutions(:,1), solutions(:,2),'bx');
hold on;
plot(solutions(:,3), solutions(:,4),'cx');

%% Backtracking each possible solution
possible_positions_after = solutions;
possible_positions_before(:,1:2) = solutions(:,1:2) - movement4(sample_step);
possible_positions_before(:,3:4) = solutions(:,3:4) - movement6(sample_step);









%% Calculate all possible positions before movement
pos2_after = [0, 0]; %Here K2 was at the origin
O2x = pos2_after(1);
O2y = pos2_after(2);
pos2_real = data_GOD2(sample_step-1, [1, 2]+1);
pos4_real = data_GOD4(sample_step-1, [1, 2]+1);
pos6_real = data_GOD6(sample_step-1, [1, 2]+1);
r24 = sqrt(  (pos2_real(1) - pos4_real(1))^2 + (pos2_real(2) - pos4_real(2))^2  );
r26 = sqrt(  (pos2_real(1) - pos6_real(1))^2 + (pos2_real(2) - pos6_real(2))^2  );
r46 = sqrt(  (pos4_real(1) - pos6_real(1))^2 + (pos4_real(2) - pos6_real(2))^2  );
syms O4y O6x O6y
from_x = O2x - r24;
to_x = O2x + r24;
% resolution = 100
O4x = linspace(from_x, to_x, resolution);
for j = 1:size(O4x,2)
    %Circle 1
    eq_circle24 = (O4x(j) - O2x)^2 + (O4y - O2y)^2 == r24^2;
    %Circle 2
    eq_circle26 = (O6x - O2x)^2 + (O6y - O2y)^2 == r26^2;
    %Distance between O4 and O6
    eq_distO4O6 = sqrt((O4x(j) - O6x)^2 + (O4y - O6y)^2) == r46;
    disp(['Eqn system number: ' num2str(j)]);
    
end
%%
solutions = [];
%we go thorugh each given O4x
row = 1;
for it1 = 1:size(O4x, 2)
    %for each O4x there can be multiple O4y solutions
    for it2 = 1:size(O4y_ans{it1},1)
        solutions(row,:) = [O4x(it1), double(O4y_ans{it1}(it2)), double(O6x_ans{it1}(it2)), double(O6y_ans{it1}(it2)) ];
        row = row + 1;
    end
end

%% Saving it
possible_positions_before = solutions;

%% Finding the minimum
dist_i = 1;
for it1 = 1:size(possible_positions_after, 1)
    for it2 = 1:size(possible_positions_before, 1)
        distances(dist_i,1) = (possible_positions_after(it1,1) - possible_positions_before(it2,1)).^2 + ...
                    (possible_positions_after(it1,2) - possible_positions_before(it2,2)).^2;
        dist_i = dist_i + 1;
    end
end

dist_i = 1;
for it1 = 1:size(possible_positions_after, 1)
    for it2 = 1:size(possible_positions_before, 1)
        distances(dist_i,2) = (possible_positions_after(it1,3) - possible_positions_before(it2,3)).^2 + ...
                    (possible_positions_after(it1,4) - possible_positions_before(it2,4)).^2;
        dist_i = dist_i + 1;
    end
end

 
% distances(:,1) = (possible_positions_after(:,1) - possible_positions_before(:,1)).^2 + ...
%                     (possible_positions_after(:,2) - possible_positions_before(:,2)).^2;
% distances(:,2) = (possible_positions_after(:,3) - possible_positions_before(:,3)).^2 + ...
%                     (possible_positions_after(:,4) - possible_positions_before(:,4)).^2;
                
%% Plot
close all
figure(2)
% plot(distances(:,1))
% hold on;
% plot(distances(:,2))
% hold on;
starting = 1; ending = size(distances,1);
a = 1; b = ones(1,100) / 100;
filtered_stuff = filter(b,a,distances(:,1) + distances(:,2));
plot(filtered_stuff);
% plot(distances(:,1) + distances(:,2))

hold on;