

%% Reading in the data
clear all; close all; clc
direction = 1; %0 if forward speed
%1 if right speed
step_size = 10;

kilo_uid = '4';
if direction == 0
    %Forward
    data_GOD = csvread(['alma/forward_speed_test3/data_GOD' kilo_uid '.csv']);
elseif direction == 1
    %Right
    data_GOD = csvread(['alma/right_speed_test3/data_GOD' kilo_uid '.csv']);
end

% figure(1)
% plot(data_GOD(:,end-1), data_GOD(:,2));

%%
vect_differences = diff(data_GOD(:,2:3));
time_differences = diff(data_GOD(:,1));

delta_s = (vect_differences(:,1).^2 + vect_differences(:,2).^2).^0.5;
delta_t = time_differences;


delta_x = vect_differences(:,1);
delta_y = vect_differences(:,2);


speed_forward = data_GOD(2:end,end-1);
speed_right = data_GOD(2:end,end);

% speed_conversion = [speed_forward delta_s]
% speed_conversion = [speed_forward(1:step_size:end), delta_s(1:step_size:end)]
speed_conversion = [speed_right(1:step_size:end), delta_s(1:step_size:end)]

% figure(1);
% plot(delta_s);
% title('distance change (true speed) - timestep diagram');

figure(1)
plot(data_GOD(:,2), data_GOD(:,3))
xlim([-0.02 0.02]);
ylim([-0.08 -0.04]);



figure(2);
subplot(3,1,1);
plot(speed_forward,delta_x);
title('delta x');
subplot(3,1,2);
plot(speed_right,delta_y);
title('delta y');
subplot(3,1,3);
plot(delta_s);
hold on;
plot(abs(delta_x));
plot(abs(delta_y));
title('delta s');

%%
syms Ox Oy r

j = 1;
next_diff = 5;
for i = 1:100:size(data_GOD,1) - next_diff
    P1 = i;
    P2 = P1 + next_diff;
    P3 = P2 + next_diff;
    x = data_GOD(P1,2);
    y = data_GOD(P1,3);
    eqn1 = (x - Ox)^2 + (y - Oy)^2 == r^2;
    x = data_GOD(P2,2);
    y = data_GOD(P2,3);
    eqn2 = (x - Ox)^2 + (y - Oy)^2 == r^2;
    x = data_GOD(P3,2);
    y = data_GOD(P3,3);
    eqn3 = (x - Ox)^2 + (y - Oy)^2 == r^2;
    
    [a, b, c] = solve([eqn1, eqn2, eqn3], [Ox Oy r]);
    a = double(a);
    b = double(b);
    c = double(c);
    Ox_saved(j) = a(2);
    Oy_saved(j) = b(2);
    r_saved(j) = c(2);
    
    j = j + 1;
end
%%
Ox_saved = abs(Ox_saved);
Oy_saved = abs(Oy_saved);
figure(3)
subplot(4,1,1)
plot(r_saved);
title('r saved');
subplot(4,1,2)
plot(Ox_saved, Oy_saved);
title('Ox & Oy ');
subplot(4,1,3)
plot(Ox_saved);
title('Ox saved');
subplot(4,1,4)
plot(Oy_saved);
title('Oy saved');
